﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//using MySql.Data.MySqlClient;

/*
namespace EnergyLogReader
{
    class ExportToMysql
    {
        #region MySql Configutation
        private string _sMySqlHostname = "db1.domain.com";
        private int _iMySqlPort = 3306;
        private string _sMySqlDatabase = "energylog";
        private string _sMySqlUsername = "username";
        private string _sMySqlPassword = "password";
        public string MySqlHostname
        {
            get { return _sMySqlHostname; }
            set {
                if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
                {
                    _sMySqlHostname = value;                    
                }
            }
        }
        public int MySqlPort
        {
            get { return _iMySqlPort; }
            set {
                if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
                {
                    _iMySqlPort = value;
                }
            }
        }
        public string MySqlUsername
        {
            get { return _sMySqlUsername; }
            set {
                if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
                {
                    _sMySqlUsername = value;
                }
            }
        }
        public string MySqlPassword
        {
            //get { return string.Empty; }
            set {
                if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
                {
                    _sMySqlPassword = value;
                }
            }
        }
        public string MysqlDatabase
        {
            get { return _sMySqlDatabase; }
            set {
                if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
                {
                    _sMySqlDatabase = value;
                }
            }
        }
        MySqlConnection _mysqlConnection = new MySqlConnection();

        private void MySqlPrepare()
        {
            MySqlConnectionStringBuilder sb = new MySqlConnectionStringBuilder();
            sb.Server = _sMySqlHostname;
            sb.Port = Convert.ToUInt32(_iMySqlPort);
            sb.UserID = _sMySqlUsername;
            sb.Password = _sMySqlPassword;
            sb.Database = _sMySqlDatabase;

            if (_mysqlConnection.State == System.Data.ConnectionState.Closed)
            {
                _mysqlConnection.ConnectionString = sb.ConnectionString;
            }
        }
        private bool MysqlIsReady()
        {
            return (_mysqlConnection.State == System.Data.ConnectionState.Open);
        }

        #endregion
        #region Table Settings
        private string _sLogTable = "el_loglines";
        private string _sLogTableView = "el_loglines_va_w";
        private bool TableCheck()
        {
            string sTestString = "SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = '" + _sMySqlDatabase + "' AND table_name IN('" + _sLogTable + "','" + _sLogTableView + "');";

            MySqlCommand cmd = new MySqlCommand(sTestString, _mysqlConnection);
            MySqlDataReader myRdr;

            if (MysqlIsReady())
            {
                myRdr = cmd.ExecuteReader();

                if (myRdr.Read())
                {
                    if (myRdr.GetInt32(0) == 2)
                    {
                        myRdr.Close();
                        return true;
                    }
                }
                myRdr.Close();            
                
            }

            
            return false;
        }


        #endregion

        public ExportToMysql(Reader logReader)
        {
            _Reader = logReader;
        }

        public int StartExport()
        {
            MySqlPrepare();

            try
            {
                _mysqlConnection.Open();                
            }
            catch (MySqlException ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message);
                return -1;
            }

            if (!TableCheck())
            {
                return -1;                
            }

            string sBaseInsert = "INSERT INTO " + _sLogTable + " (unit_id, date, voltage, current, powerfactor) VALUES ";
            string sValues = string.Empty;
            
            foreach (Reader.LT_DATA.LTD_LINE line in _Reader.DataLog.LogLines)
            {
                //if (sValues != string.Empty) { sValues += ","; }

                MySqlCommand cmd = new MySqlCommand();
                cmd.Connection = _mysqlConnection;

                sValues = string.Empty;
                sValues += "(" + _Reader.InfoLog.UnitID + ", '" + line.LogTime.ToString("yyyy-MM-dd HH:mm")+"'";
                sValues += ", " + line.Voltage.ToString().Replace(',', '.') + ", " + line.Current.ToString().Replace(',', '.') + ", " + line.PowerFactor.ToString().Replace(',', '.') + ")";

                cmd.CommandText = sBaseInsert + sValues;

                try
                {
                    cmd.ExecuteNonQuery();
                }
                catch (MySqlException ex)
                {
                    if (ex.ErrorCode == -2147467259) //Duplicatie entry?
                    {
                        //Do not care???
                        //UnitID and Date are PrimaryKey
                    }
                    else
                    {
                        throw new Exception(ex.ErrorCode + ": " + ex.Message);
                    }
                    System.Diagnostics.Debug.WriteLine(ex.ErrorCode + ": " + ex.Message);
                }
            }

            //MySqlCommand cmd = new MySqlCommand(sBaseInsert + sValues, _mysqlConnection);
            //System.Windows.Forms.MessageBox.Show(cmd.ExecuteNonQuery().ToString());


            


            return 0;
        }
        
    }
}


*/